﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
//COM组件接口

using System.Runtime.InteropServices;
using System.Threading;

namespace Test1
{
    public partial class Form1 : Form
    {

        Thread    mThread;                      //线程
        bool      bAutoExecuteRun=false;        //连续运行标志
       
        double    dLLimmit       =140.5;        //卡尺测量尺寸下限值
        double    dULimmit       = 140.74;      //卡尺测量尺寸上限值

        /*************************设置控件自适应窗口*******************************/

        private float x;//定义当前窗体的宽度
        private float y;//定义当前窗体的高度
        private void setTag(Control cons)
        {
            foreach (Control con in cons.Controls)
            {
                con.Tag = con.Width + ";" + con.Height + ";" + con.Left + ";" + con.Top + ";" + con.Font.Size;
                if (con.Controls.Count > 0)
                {
                    setTag(con);
                }
            }
        }
        private void setControls(float newx, float newy, Control cons)
        {
            //遍历窗体中的控件，重新设置控件的值
            foreach (Control con in cons.Controls)
            {
                //获取控件的Tag属性值，并分割后存储字符串数组
                if (con.Tag != null)
                {
                    string[] mytag = con.Tag.ToString().Split(new char[] { ';' });
                    //根据窗体缩放的比例确定控件的值
                    con.Width = Convert.ToInt32(System.Convert.ToSingle(mytag[0]) * newx);//宽度
                    con.Height = Convert.ToInt32(System.Convert.ToSingle(mytag[1]) * newy);//高度
                    con.Left = Convert.ToInt32(System.Convert.ToSingle(mytag[2]) * newx);//左边距
                    con.Top = Convert.ToInt32(System.Convert.ToSingle(mytag[3]) * newy);//顶边距
                    Single currentSize = System.Convert.ToSingle(mytag[4]) * newy;//字体大小
                    con.Font = new Font(con.Font.Name, currentSize, con.Font.Style, con.Font.Unit);
                    if (con.Controls.Count > 0)
                    {
                        setControls(newx, newy, con);
                    }
                }
            }
        }
        /*****************************************************************/

        public Form1()
        {
            InitializeComponent();
            x = this.Width;
            y = this.Height;
            setTag(this);
        }

        //加载初始化
        private void Form1_Load(object sender, EventArgs e)
        {

            //axCKVisionCtrl1.LoadConfigure("C:/Users/HUAWEI/Desktop/test.vscf");//设置打开程序后自动加载工程文件
            //axCKVisionCtrl1.Redraw();

            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;

            EDIT_PROC.Enabled    = false;                        //按钮初始状态
            EXECUTE_ONCE.Enabled = true;
           
            RUN.Enabled          = true;
            STOP.Enabled         = false;

            CALIPER.Enabled      = false;
            MATCH.Enabled        = false;


            axCKVisionCtrl1.SetLanguageKey("sch");               //设置编辑流程语言，“sch”为中文，“eng”为英文
           

            mThread = new Thread(new ThreadStart(WorkThread));   //创建线程，用于连续运行下循环执行流程
            mThread.IsBackground = true;
            mThread.Start();
           
        }

        //线程执行方法
        private void WorkThread()
        {
            
            while (true)
            {
                
                if (bAutoExecuteRun)
                {
                    axCKVisionCtrl1.Execute(0);
                    axCKVisionCtrl1.Redraw();

                    //获取用户变量的值，分别对应OK数、NG数、总数，并显示在生产统计栏中
                    double OkNum = 0.0;
                    double NgNum = 0.0;
                    double SumNum = 0.0;
                    object objOkNum = new VariantWrapper(OkNum);
                    object objNgNum = new VariantWrapper(NgNum);
                    object objSumNum = new VariantWrapper(SumNum);
                    axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 100, 0, ref objOkNum);
                    axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 101, 0, ref objNgNum);
                    axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 102, 0, ref objSumNum);
                    double rate = Convert.ToDouble(objOkNum) / Convert.ToDouble(objSumNum) * 100;     //良率
                    okcount.BeginInvoke(new Action(() =>
                          {
                              okcount.Text = string.Format("{0:F0}", objOkNum);
                          }));
                    ngcount.BeginInvoke(new Action(() =>
                          {
                              ngcount.Text = string.Format("{0:F0}", objNgNum);
                          }));
                    sum.BeginInvoke(new Action(() =>
                          {
                              sum.Text = string.Format("{0:F0}", objSumNum);
                          }));
                    percent.BeginInvoke(new Action(() =>
                         {
                              percent.Text = string.Format("{0:F3}%", rate);
                         }));

                    //获取当前页面中所有产品外观尺寸，并显示在列表中
                    double MatchNum = 0.0;
                    object objMtNum = new VariantWrapper(MatchNum);
                     axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("轮廓匹配"),100, 0, ref objMtNum);
                     int num = Convert.ToInt32(objMtNum);
                     dataGridView1.BeginInvoke(new Action(() => {
                         dataGridView1.Rows.Clear();
                         for (int i = 0; i < num; i++) {

                             double result    = 0.0;
                             double ResData   = 0.0;
                             object objResult = new VariantWrapper(result);
                           
                             if (axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("定义数组"), 200, i, ref objResult)) {
                                
                                 ResData = Convert.ToDouble(objResult);
                             }

                            
                                 dataGridView1.Rows.Add();
                                 dataGridView1.Rows[i].Cells[0].Value = i + 1;
                                 dataGridView1.Rows[i].Cells[1].Value = "外观尺寸";
                                 dataGridView1.Rows[i].Cells[3].Value = ResData;
                                 dataGridView1.Rows[i].Cells[4].Value = dLLimmit;
                                 dataGridView1.Rows[i].Cells[5].Value = dULimmit;
                                 if (dLLimmit <= ResData && ResData <= dULimmit) {
                                     dataGridView1.Rows[i].Cells[2].Value = "OK";
                                 }
                                 else {
                                     dataGridView1.Rows[i].Cells[2].Value = "NG";
                                 }
                           
                         }
                     }));
                  
                    Thread.Sleep(100);
                }
                
            }

        }
        private void axCKVisionCtrl1_Draw(object sender, AxCKVisionCtrlLib._DCKVisionCtrlEvents_DrawEvent e)
        {

        }

        //弹出编辑流程窗口
        private void EDIT_PROC_Click(object sender, EventArgs e)
        {
            
           axCKVisionCtrl1.ShowEditor("编辑流程",0);
        }

        //单次执行流程
        private void EXECUTE_ONCE_Click(object sender, EventArgs e)
        {

            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                axCKVisionCtrl1.Execute(0);
                //axCKVisionCtrl1.Execute(0);
                axCKVisionCtrl1.Redraw();

                double OkNum     = 0.0;
                double NgNum     = 0.0;
                double SumNum    = 0.0;
                double MatchNum  = 0.0;
                
                object objOkNum  = new VariantWrapper(OkNum);
                object objNgNum  = new VariantWrapper(NgNum);
                object objSumNum = new VariantWrapper(SumNum);
                object objMtNum  = new VariantWrapper(MatchNum);

                axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 100, 0, ref objOkNum);
                axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 101, 0, ref objNgNum);
                axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("用户变量"), 102, 0, ref objSumNum);
                double rate = Convert.ToDouble(objOkNum) / Convert.ToDouble(objSumNum)*100;
                okcount.Text = string.Format("{0:F0}", objOkNum);
                ngcount.Text = string.Format("{0:F0}", objNgNum);
                sum.Text = string.Format("{0:F0}", objSumNum);
                percent.Text = string.Format("{0:F3}%", rate);
                axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("轮廓匹配"),100, 0, ref objMtNum);
                int num = Convert.ToInt32(objMtNum);
               
                dataGridView1.Rows.Clear(); 
                for (int i = 0; i < num;i++ )
                {
                    dataGridView1.Rows.Add();
                    dataGridView1.Rows[i].Cells[0].Value = i + 1;
                    dataGridView1.Rows[i].Cells[1].Value="外观尺寸";
                    double result = 0.0;
                    double ResData = 0.0;
                    object objResult = new VariantWrapper(result);
                    if (axCKVisionCtrl1.GetValue(axCKVisionCtrl1.GetTool("定义数组"),200,i,ref objResult))
                    {
                         ResData = Convert.ToDouble(objResult);
                        dataGridView1.Rows[i].Cells[3].Value = ResData;
                    }
                    else 
                    {
                        dataGridView1.Rows[i].Cells[3].Value = 0.0;
                    }
                    dataGridView1.Rows[i].Cells[4].Value = dLLimmit;
                    dataGridView1.Rows[i].Cells[5].Value = dULimmit;
                    if (dLLimmit<=ResData&&ResData<=dULimmit)
                    {
                        dataGridView1.Rows[i].Cells[2].Value = "OK";
                    }
                    else
                    {
                        dataGridView1.Rows[i].Cells[2].Value = "NG";
                    }
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not execute proc.Original error:" + ex.Message);

            }
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        
        private void 打开项目ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                OpenFileDialog openfileDlg = new OpenFileDialog();
                openfileDlg.Filter = "vscf files (*.vscf)|*.vscf";
                openfileDlg.FilterIndex = 1;
                openfileDlg.RestoreDirectory = true;
                if (openfileDlg.ShowDialog() == DialogResult.OK)
                {
                    string strFilePathName = openfileDlg.FileName.ToString();
                    axCKVisionCtrl1.LoadConfigure(strFilePathName);
                    axCKVisionCtrl1.ZoomView(2);
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not read file from disk.Original error:" + ex.Message);
            }

        }

        private void 保存项目ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                SaveFileDialog savefileDlg = new SaveFileDialog();
                savefileDlg.Filter = "ckcf files (*.vscf)|*.vscf";
                savefileDlg.FilterIndex = 1;
                savefileDlg.RestoreDirectory = true;

                if (savefileDlg.ShowDialog() == DialogResult.OK)
                {
                    string strSavePathName = savefileDlg.FileName.ToString();
                    bool isSave = axCKVisionCtrl1.SaveConfigure(strSavePathName);
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not save file to disk.Original error:" + ex.Message);

            }

        }

        private void 关闭项目ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                axCKVisionCtrl1.UnloadConfigure();
                axCKVisionCtrl1.Redraw();
                dataGridView1.Rows.Clear();
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not close proc.Original error:" + ex.Message);

            }

        }

        private void 退出ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                else 
                {
                    DialogResult dr = MessageBox.Show("确定关闭程序前已保存工程文件？", "关闭提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
                    if (dr == DialogResult.OK)
                    {
                        //点确定的代码
                        Application.Exit();
                    }
                    else
                    {
                        //点取消的代码 
                        //bCloseMark = false;
                    }
                    Thread.Sleep(10);
                    
                }


                
                
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not exit.Original error:" + ex.Message);

            }

        }
        protected override void WndProc(ref Message msg) 
{ 
    //Windows系统消息，winuser.h文件中有WM_...的定义
    //十六进制数字，0x是前导符后面是真正的数字
    const int WM_SYSCOMMAND = 0x0112; 
    //winuser.h文件中有SC_...的定义
    const int SC_CLOSE = 0xF060;  

     if (msg.Msg == WM_SYSCOMMAND && ((int)msg.WParam == SC_CLOSE)) 
     { 
             // 点击winform右上关闭按钮 
             // 加入想要的逻辑处理
             // 改关闭效果为最小化
             //this.WindowState = FormWindowState.Minimized;
         if (bAutoExecuteRun)
         {
            
             MessageBox.Show("退出程序 请先停止连续运行！");
             Thread.Sleep(100);
             return;
         }
         DialogResult dr = MessageBox.Show("确定关闭程序前已保存工程文件？", "关闭提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
         if (dr == DialogResult.OK)
         {
             //点确定的代码
             Application.Exit();
         }
         else
         {
             //点取消的代码 
         }
             return;//阻止了窗体关闭
     } 
     base.WndProc(ref msg); 
}


        private void 关于ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axCKVisionCtrl1.AboutBox();
        }

        private void ZOOM_IN_Click(object sender, EventArgs e)
        {
            axCKVisionCtrl1.ZoomView(0);
        }

        private void ZOOM_OUT_Click(object sender, EventArgs e)
        {
            axCKVisionCtrl1.ZoomView(1);
        }

        private void ZOOM_FIT_Click(object sender, EventArgs e)
        {
            axCKVisionCtrl1.ZoomView(2);
        }

        private void ZOOM_ONE_Click(object sender, EventArgs e)
        {
            axCKVisionCtrl1.ZoomView(3);
        }

        //开始连续运行
        private void RUN_Click(object sender, EventArgs e)
        {
            bAutoExecuteRun = true;
            RUN.Enabled     = false;
            STOP.Enabled    = true;
        }

        //停止连续运行
        private void STOP_Click(object sender, EventArgs e)
        {
            bAutoExecuteRun = false;
            RUN.Enabled     = true;
            STOP.Enabled    = false;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            bAutoExecuteRun = false;
            mThread.Abort();
            axCKVisionCtrl1.UnloadConfigure();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            
           
            switch (e.CloseReason)
            {
                //应用程序要求关闭窗口
                case CloseReason.ApplicationExitCall:
                    e.Cancel = false; //不拦截，响应操作
                    break;
                //自身窗口上的关闭按钮
                case CloseReason.FormOwnerClosing:
                    e.Cancel = true;//拦截，不响应操作
                    break;
                //MDI窗体关闭事件
                case CloseReason.MdiFormClosing:
                    e.Cancel = true;//拦截，不响应操作
                    break;
                //不明原因的关闭
                case CloseReason.None:
                    break;
                //任务管理器关闭进程
                case CloseReason.TaskManagerClosing:
                    e.Cancel = false;//不拦截，响应操作
                    break;
                //用户通过UI关闭窗口或者通过Alt+F4关闭窗口
                case CloseReason.UserClosing:
                    e.Cancel = true;//拦截，不响应操作
                    break;
                //操作系统准备关机
                case CloseReason.WindowsShutDown:
                    e.Cancel = false;//不拦截，响应操作
                    break;
                default:
                    break;
            }
        }

        private void 管理员权限ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            login lfrm = new login();
            lfrm.ShowDialog();
            if (lfrm.isValidUse)
            {
                EDIT_PROC.Enabled    = true;
                EXECUTE_ONCE.Enabled = true;
                CALIPER.Enabled      = true;
                MATCH.Enabled        = true;
             
            }
        }

        private void 操作员权限ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("退出管理员权限！");
            EDIT_PROC.Enabled    = false;
            CALIPER.Enabled = false;
            MATCH.Enabled = false;
            //EXECUTE_ONCE.Enabled = false;
           
        }

        //获取工具返回数据
       /* private void GET_VALUE_Click(object sender, EventArgs e)
        {
            if (bAutoExecuteRun)
            {
                MessageBox.Show("请先停止连续运行！");
                return;
            }
            int idTool   = axCKVisionCtrl1.GetTool(toolname.Text);
            int DataID   = Convert.ToInt32(toolID.Text);
            double value = 0.0;
            object objValue = new VariantWrapper(value);
            if (axCKVisionCtrl1.GetValue(idTool, DataID, 0, ref objValue) == true)
            {
                returndata.Text = string.Format("{0:F3}", objValue);
            }
            else
            {
                MessageBox.Show("获取数据失败！");
            }
        }*/

        //数据统计清零
        private void DATA_CLEAR_Click(object sender, EventArgs e)
        {
            if (bAutoExecuteRun)
            {
                MessageBox.Show("请先停止连续运行！");
                return;
            }
            DialogResult dr;
             dr = MessageBox.Show("确定要清零数据统计？","提示",
             MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if(dr==DialogResult.Yes)
           {
             
                axCKVisionCtrl1.SetValue(axCKVisionCtrl1.GetTool("用户变量"), 100, 0, 0);
                axCKVisionCtrl1.SetValue(axCKVisionCtrl1.GetTool("用户变量"), 101, 0, 0);
                axCKVisionCtrl1.SetValue(axCKVisionCtrl1.GetTool("用户变量"), 102, 0, 0);
                okcount.Text = string.Format("{0:F0}", 0);
                ngcount.Text = string.Format("{0:F0}", 0);
                sum.Text = string.Format("{0:F0}", 0);
                percent.Text = string.Format("{0:F3}%", 0);
            }
            else
            {
                return;
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            float newx = (this.Width) / x;
            float newy = (this.Height) / y;
            setControls(newx, newy, this);
        }

        private void 技术员权限ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TechForm lfrm = new TechForm();
            lfrm.ShowDialog();
            if (lfrm.isValidUse)
            {
                EDIT_PROC.Enabled = false;
                EXECUTE_ONCE.Enabled = true;

                CALIPER.Enabled = true;
                MATCH.Enabled = true;
               
            }
        }

        //弹出轮廓匹配属性窗口
        private void MATCH_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                axCKVisionCtrl1.ShowProperty(axCKVisionCtrl1.GetTool("轮廓匹配"));
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not set match parameter.Original error:" + ex.Message);
            }
        }

        //弹出卡尺测量属性窗口
        private void CALIPER_Click(object sender, EventArgs e)
        {
            try
            {
                if (bAutoExecuteRun)
                {
                    MessageBox.Show("请先停止连续运行！");
                    return;
                }
                axCKVisionCtrl1.ShowProperty(axCKVisionCtrl1.GetTool("卡尺测量"));
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error:Could not set user value.Original error:" + ex.Message);
            }

        }
   
    }
}
